#pragma once

#include "ehs/EHS.h"
#include "ehs/Str.h"

namespace ehs
{
	class Button
	{
	private:
		Str_8 name;
		UInt_32 hash;

	public:
		Button();

		Button(const Str_8& name);

		Button(const Button& key);

		Button& operator=(const Button& key);

		bool operator==(const Button& key) const;

		bool operator!=(const Button& key) const;

		Str_8 GetName() const;

		UInt_32 GetHash() const;
	};
}
